#include "vga_t.hpp"

#include "include/boucane.hpp"

#define MAX_COL 80
#define MAX_LINE 25

VIDEO_STATE VS={
  (u8 *)0xB8000,
  0,
  0,
  BLACK,
  GRAY,
};

void vga_t_init(){
  PAGING_MAP(0xB8000);
  PAGING_MAP(0xB8000+4096);
}

void vga_t_putchar(char c){
  // Handle newline here
  if(c=='\n'){
    VS.col=0;
    VS.line+=1;
    if(VS.line>=MAX_LINE){
      VS.line=MAX_LINE-1;
      vga_t_scrollup();
    }
    return;
  }
  
  // Print char
  VS.mem[VS.col*2+MAX_COL*VS.line*2]=c;
  VS.mem[VS.col*2+MAX_COL*VS.line*2+1]=VS.fg|VS.bg<<4;
  
  // Refresh location
  VS.col+=1;
  if(VS.col>= MAX_COL){
    VS.col=0;
    VS.line+=1;
    if(VS.line>=MAX_LINE){
      VS.line=MAX_LINE-1;
      vga_t_scrollup();
    }
  }
}

void vga_t_clear(){
  for(u8 i=0;i<MAX_LINE;i++){
    vga_t_scrollup();
  }
}

void vga_t_scrollup(){
  // Move VS.line up
  for(u8 i=1;i<=MAX_LINE;i++){
    for(u8 j=0;j<=MAX_COL;j++)
      VS.mem[j*2+MAX_COL*(i-1)*2]=VS.mem[j*2+MAX_COL*i*2];
  }
  // Clear last VS.line
  for(u8 i=0;i<=MAX_COL;i++){
    VS.mem[i*2+MAX_COL*(MAX_LINE-1)*2]='\0';
  }
}
